#include "extern.h"
#include "aClient.h"
#include "player.h"
#include "options.h"
#include "flags.h"

void do_fight(char *u)
{
  aClient *ni;
  Player *battle;
  
  char *nick = strtok(NULL, " ");
  
  if (!nick)
    {
	  notice(s_GameServ, u, "SYNTAX: /msg <S FIGHT PLAYER");
	  return;
    }
  else if (!(ni = find(u)))
    {
	  notice(s_GameServ, u, "Fatal error. Contact a(n) <S admin. buf: %s", strtok(NULL, ""));
	  return;
    }
  else if (isIgnore(ni))
    {
#ifdef DEBUGMODE
	  log("Ignoring %s.", ni->getNick());
#endif
	  return;
    }
  else if (!is_playing(ni))
    {
	  notice(s_GameServ, u, "You are not playing!");
	  return;
    }
  
  updateTS(ni->stats);
  
  if (ni->stats->getPlayerFights() <= 0)
    {
	  ni->stats->setPlayerFights(0); // just to be safe
	  notice(s_GameServ, u, "You are out of player fights for the "\
			 "day. You have to wait until tomorrow!");
    }
  else if (!(battle = findplayer(nick)))
    {
	  notice(s_GameServ, u, "Player %s not found!", nick);
    }
  else if (!isAlive(ni->stats))
    {
	  notice(s_GameServ, u, "You are dead. Wait until tomorrow to fight others!");
    }
  else if (!is_playing(battle->getClient()))
    {
	  notice(s_GameServ, u, "You can't attack %s while they aren't playing!", nick);
    }
  
  /* offline fighting not available yet
	 else if (!(fight = finduser(nick)))
	 {
	 ni->stats->battle = battle;
	 battle->battle = ni;
	 setYourTurn(ni->stats);
	 clearYourTurn(battle->stats);
	 
	 notice(s_GameServ, u, "You decide to fight %s while they're "\
	 "not in the realm!",
	 battle->stats->name.c_str());
	 display_players(u);
	 }
  */
  else if (stricmp(ni->stats->getName().c_str(), battle->getName().c_str()) == 0)
    {
	  notice(s_GameServ, u, "Are you trying to commit suicide!?");
    }
  else if (!isAlive(battle))
    {
	  notice(s_GameServ, u, "They are dead. Cannot fight dead players!");
    }
  else if (player_fight(battle->getClient()))
    {
	  notice(s_GameServ, u, "%s is fighting %s already!", battle->getName().c_str(), battle->getBattle()->stats->getName().c_str());
    }
  else if (master_fight(battle->getClient()))
    {
	  notice(s_GameServ, u, "%s is fighting their master!", battle->getName().c_str());
    }
  else if (is_fighting(battle->getClient()))
    {
	  notice(s_GameServ, u, "%s is fighting %s already!", battle->getName().c_str(), battle->getMonster()->name.c_str());
    }
  else if (!isAdmin(ni) && isFairFights() && (ni->stats->getStrength()/2 - battle->getDefense()) > battle->getHP())
    {
	  notice(s_GameServ, u, "Fair fighting is enabled, and you're too strong for %s!", battle->getName().c_str());
    } 
  else if (ni->stats->getLevel() - battle->getLevel() > maxbfightdistance)
    {
	  // You can't fight someone below you by more than X level(s)
	  // level 12 can fight level (12 - X) but not < (12 - X)
	  notice(s_GameServ, u, "You may not fight %s. You're too strong!", 
			 battle->getName().c_str());
    }
  else if (battle->getLevel() - ni->stats->getLevel() > maxafightdistance)
    {
	  // You can't fight someone above you by more than X level(S)
	  // level 1 can fight level (1 + X), but not > (1 + X)
	  notice(s_GameServ, u, "%s, do you really have a death wish? Try the forest you "\
			 "weakling!", ni->stats->getName().c_str());
    }
  else
	{
	  // Set your battle pointer to the other player
	  ni->stats->setBattle(battle->getClient());
	  
	  // Set the other player's battle pointer to you
	  battle->setBattle(ni);
	  	  
	  // The initiator gets the first move (perhaps this should be 50/50)
	  setYourTurn(ni->stats);
	  clearYourTurn(battle);
	  
	  // Initiate Battle sequence!
	  ni->stats->subtractPlayerFights(1);
	  
	  notice(s_GameServ, u, "You challenge %s to an online duel!", battle->getName().c_str());
	  notice(s_GameServ, c_Forest, "%s walks up and hits %s in the face! Let's see who will bite the dust.",
			 ni->stats->getName().c_str(), battle->getName().c_str()); /* DrLnet - Modified by Kain*/
	  
	  notice(s_GameServ, battle->getClient()->getNick(), "%s has challenged you to an online duel!", ni->stats->getName().c_str());
	  notice(s_GameServ, battle->getClient()->getNick(), "%s gets to go first "\
			 "because they initiated!", ni->stats->getName().c_str());
	  notice(s_GameServ, battle->getClient()->getNick(), "Please wait while %s decides what to do.", ni->stats->getName().c_str());
	  display_players(ni);
	}
}
