#include "extern.h"
#include "options.h"
#include "aClient.h"
#include "player.h"
#include "flags.h"

#include <list>
#include <algorithm>
using namespace std;

void do_identify(char *u)
{
  char *password, *name;
  aClient *user;
  Player *p;
  name = strtok(NULL, " ");
  password = strtok(NULL, " ");
  if (!password || !name)
    {
	  notice(s_GameServ, u, "SYNTAX: /msg <S IDENTIFY NAME PASSWORD");
    }
  else if (!(user = find(u)))
    {
	  notice(s_GameServ, u, "Fatal error. Cannot find aClient. Buf: %s", strtok(NULL, ""));
	  log("Error: aClient not found: %s", u);
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
	  log("Ignoring %s.", user->getNick());
#endif
	  return;
    }
  else if (!(p = findplayer(name)))
	{
	  notice(s_GameServ, u, "Player %s not found", name);
	}
  else if (is_playing(user))
    {
	  notice(s_GameServ, u, "You are already playing!");
    }
  else if (is_playing(p->getClient()) && !isAdmin(user))
    {
	  notice(s_GameServ, u, "That player has already identified.");
    }
  else if (!check_password(name, password) && !isAdmin(user))
    {
	  notice(s_GameServ, u, "Password incorrect");
    }
  else
	{
	  list<Player*>::iterator iter;
	  unsigned long hv = iHASH((unsigned char *) p->getName().c_str());

	  iter = find(players[hv].begin(), players[hv].end(), p);

	  if (iter == players[hv].end())
		{
		  notice(s_GameServ, u, "Fatal error. Contact <S Admin. Buf: %s", 
				 strtok(NULL, ""));
		  return;
		}
	  // Make sure the other user is logged out
	  logout(p->getClient());
	  
	  user->stats = p;
	  p->setClient(user);
	  updateTS(p);
		
		
#ifdef DEBUGMODE
	    log("Player %s IRC: %s Identified", user->stats->getName().c_str(), 
			user->getNick());
#endif
		//Set the playing flag
		setPlaying(user);
		
		// Update the last login time
		user->stats->lastlogin = time(NULL);

		notice(s_GameServ, u, "Password Accepted. Identified.");
		showNews(u, todaysnews);
    }
}
