#include "extern.h"
#include "aClient.h"
#include "flags.h"
#include "options.h"
#include "level.h"

void do_master(char *u)
{
  aClient *user;
  
  
  if (!(user = find(u)))
    {
	  notice(s_GameServ, u, "Fatal error. Contact a(n) <S admin. buf: %s", strtok(NULL, ""));
	  return;
    }
  else if (isIgnore(user))
    {
#ifdef DEBUGMODE
	  log("Ignoring %s.", user->getNick());
#endif
	  return;
    }
  else if (!is_playing(user))
    {
	  notice(s_GameServ, u, "You must be playing to see your master!");
	  return;
    }
  else if (is_fighting(user))
    {
	  notice(s_GameServ, u, "You're in the middle of a fight! Pay attention!");
	  return;
    }
  else if (!isAlive(user->stats))
    {
	  notice(s_GameServ, u, "You're dead. Wait until tomorrow to see your master!");
	  return;
    }
  
  updateTS(user->stats);
  
  char *cmd = strtok(NULL, " ");
  Player *p = user->stats;
  long int need = 0;
  
  if (seenMaster(p))
    {
	  notice(s_GameServ, u, "You have already seen your master today. Wait until tomorrow to try again");
	  return;
    }
  
  if (cmd != NULL)
    {
	  switch(p->getLevel())
		{
	    case 1:
		  need = 200;
		  break;
	    case 2:
		  need = 800;
		  break;
	    case 3:
		  need = 2000;
		  break;
	    case 4:
		  need = 8000;
		  break;
	    case 5:
		  need = 20000;
		  break;
	    case 6:
		  need = 80000;
		  break;
	    case 7:
		  need = 200000;
		  break;
	    case 8:
		  need = 800000;
		  break;
	    case 9:
		  need = 2000000;
		  break;
	    case 10:
		  need = 8000000;
		  break;
	    case 11:
		  need = 20000000;
		  break;
		  
	    case REALLEVELS:
		  need = p->getExp() + 1;
		  notice(s_GameServ, u, "You are at level %d. You are the master. What's left? The DRAGON!", REALLEVELS);
		  return;
		  break;
	    default:
		  need = p->getExp() + 1; // Unknown level... don't let them fight a fake master!
		  break;
		}   
    }
  else
    {
	  notice(s_GameServ, u, "SYNTAX: MASTER {FIGHT | QUESTION}");
	  return;
    }
  
  if (stricmp(cmd, "FIGHT") == 0)
    {
	  if (p->getExp() >= need)
		{
		  setMaster(p);
		  see_master(u);
		}
	  else
	    notice(s_GameServ, u, "You are not worthy of fighting %s! You need %ld more experience.", 
			   levels[p->getLevel() - 1].master.name.c_str(), (need - p->getExp()));
	  return;
    }
  else if (stricmp(cmd, "QUESTION") == 0)
    {
	  if (p->getExp() >= need)
	    notice(s_GameServ, u, "%s looks you up and down and decides you are more ready than you will ever be.", 
			   levels[p->getLevel() - 1].master.name.c_str());
	  else
	    notice(s_GameServ, u, "You pathetic fool! You are no match for %s, %s!", 
			   levels[p->getLevel() - 1].master.name.c_str(), p->getName().c_str());
	  
	  return;
    }
  else
    {
	  notice(s_GameServ, u, "SYNTAX: MASTER {FIGHT | QUESTION}");
    }
}
